###########################
# G6Stats v4.20 by EsKiMo #
###########################

# BE SURE TO REFER TO THE ESKIMO.NFO FILE FOR MORE INSTRUCTIONS!

# As with all TCL's available, if you add to this script, please at least give
# me credit for what is mine. Also, I would appreciate it if all modified versions 
# of this script be sent to me. You make reach me at g6stats@tranceambient.com
# Also, I'd like to urge all G6FTPd users to purchase the software legally in order
# to help support them in continually develop the world's best FTP Server software
# -EsKi

#################
# CONFIGURATION #
#################

# Specify the name of your FTP server
set servername "My Server Name"

# Specify the path to the root of your G6FTP folder
# WARNING: Be sure you use forward-slashes in the g6dir definition,
# and that there is a forward slash at the end of the path!
set g6dir "c:/Program Files/G6 FTP Server/"

# Specify the path to your g6stats files
# WARNING: Be sure to use forward slashes, and end the path with a forward slash!
set g6stats_dir "c:/eggdrop/scripts/g6stats/"

# Specify the top-level incoming directory on your server
# ie, all uploads will either be in this folder, or will be a subfolder of this folder.
# NOTE: You must use forward-slashes in the path, and the path must end in a forward-slash
set incoming_dir "d:/uploads/"

# Specify the directory where you would like to keep your archived logs
# ie, the nukelog, hacklog, uplog, and authlog.
# NOTE: You must use forward-slashes in the path, and the path must end in a forward slash
# NOTE: To disable this feature, define the directory path to ""
set log_archive_dir "c:/eggdrop/logs/"

# Specify the directory where you would like a date-stamped folder be created every night at 
# midnight. Be sure that the path ends with a forward slash.
# NOTE: To disable this feature, define the directory path to ""
set midnight_dir "d:/uploads/"

# Set retain_authlog to 0 if you want your authlog to be reset at midnight with the other logs
# Set retain_authlog to 1 if you want your authlog to be retained until manually deleted
# NOTE: This is useful if you have a static IP and do not wish to have to re-authorize
# as an admin every day (or every time you reset your logs)
set retain_authlog 0

# Use the following keys to customize the format of your date-stamped folder
# %a Abbreviated weekday name (Mon, Tue, etc.). 
# %A Full weekday name (Monday, Tuesday, etc.). 
# %b Abbreviated month name (Jan, Feb, etc.). 
# %B Full month name. 
# %d Day of month (01 - 31). 
# %j Day of year (001 - 366). 
# %m Month number (01 - 12). 
# %U Week of year (00 - 52), Sunday is the first day of the week. 
# %w Weekday number (Sunday = 0). 
# %W Week of year (00 - 52), Monday is the first day of the week. 
# %y Year without century (00 - 99). 
# %Y Year with century (e.g. 1990) 
set midnight_dir_format "%m-%d"

# Define 'g6_trigger' as the trigger you want to use to invoke this script.
set g6_trigger "!MyTrigger"

# Specify whether you want the stats request to go to the NICK or to the CHAN
# 0 = Nick
# 1 = Chan
set chan_or_nick 0

# Specify the channels you want the G6STATS script to operate in.
# The number of channels is unlimited as long as there is a space between each channel.
set approved_chans "#chan1 #chan2 #chan3"

# If you want to use a GreetBot to greet new users, specify the nick of that bot.
# Please refer to FAQ for explanation of what a GreetBot is.
# NOTE: If you are NOT using a separate bot to greet new users (and would still like
# to use the GreetBot method), just define the greet_bot to the nick of your own bot.
# NOTE: Your bot must be added to the greet bot's userfile with at LEAST +hp flags before 
# the greet bot will relay your greeting to the incoming user (unless you are using your own
# bot as the greet bot)
# NOTE: To disable this feature, define the greetbot as ""
set greet_bot "GreetBot"

# Toggle whether or not you want an instructive notice to be used to greet new users
# NOTE: If using a GreetBot, there is no need to use this notice.
# 0=off, 1=on
set greetnotice_enabled 0

# 0=off (does not allow your bot to be a greetbot)
# 1=on (allows your bot to be a greetbot)
# NOTE: You will have to add all bots that will be requesting greetings from your bot
# to your userfile with at LEAST +hp flags.
set greetbot_enabled 1

# Specify the password that will be used to authorize as an administrator.
# NOTE: The password is case sensitive, and may contain spaces if you so choose.
set admin_pass "adminpassword"

# Specify the IRC nicknames of the people to be private msg'ed on IRC in the event of 
# a detected hack attempt.
# NOTE: This is not advisable on networks where nicknames are not verified
# ie, networks without services (nickserv/chanserv)
# NOTE: To disable this feature, simply define the list to ""
# NOTE: There is no limit on how many people can be msg'ed, as long as you put a space
# between each name.
set msgnotify_list "IRCNick1 IRCNick2 IRCNick3"

# Specify the people to be msg'ed via the WorldWide Pager system on ICQ in the event
# of a detected hack attempt.
# NOTE: The recipient must not have his/her ICQ set to reject WWP messages.
# NOTE: The code does not restrict the number of people that may be msg'ed, but it seems
# as if ICQ has some type of flood control in effect. Either that or their service just
# isn't 100% reliable. In any event, this works most of the time.
# NOTE: You must put a space between each ICQ number you want msg'ed
# NOTE: To disable this feature, define the list to ""
# NOTE: This may or may not work with other versions of ICQ besides the one for Windows
set icqnotify_list "ICQUIN1 ICQUIN2 ICQUIN3"

# checkdelay is the amount of time that the script will wait before checking for a new upload (in seconds)
set checkdelay 5

# Define the date that you first started keeping track of your G6FTP stats
set stats_started_date "04-20-00"

# Change the following flags to identify what flags you want to use
# to call for the different .top files, the help menu, the version info,
# and the log files.
# NOTE: Do NOT use uppercase letters in your flags!
set allflag "alltime"
set monthflag "monthtop"
set weekflag "weektop"
set dayflag "daytop"
set helpflag "help"
set infoflag "info"
set nukelog_flag "nukelog"
set uplog_flag "uplog"
set nukeflag "nuke"
set uploadcount_flag "upcount"
set resetlog_flag "resetlogs"

# Configure your color scheme using the following definitions
# 0 = white        1 = black       2 = dark blue       3 = green        4 = red        5 = maroon
# 6 = purple       7 = orange      8 = yellow          9 = lime green   10 - teal      11 - light blue
# 12 = blue        13 = pink       14 = dark grey      15 = light grey

# replycolor refers to the default color of the sitestat replies
set replycolor 4

# servercolor refers to the color your server name will be displayed
set servercolor 3

# commandcolor refers to the color that commands and special responses will be displayed
set commandcolor 10

# botcolor refers to the color your bot name will be displayed
set botcolor 3

# You MUST either remove or comment out this line in order for the script to start!
# (this is to prevent people from starting up the bot without properly configuring
# the script first)
die "ERROR LOADING G6STATS.TCL: YOU HAVE NOT YET FINISHED CONFIGURING THE SCRIPT"

# YOU HAVE REACHED THE END OF THE CONFIGURATION!

###########################################   
# DO NOT EDIT ANYTHING BEYOND THIS POINT! #
###########################################


set newup "newup.txt"
set newup_copy "newup_copy.txt"
set newup_batchfile "newup.bat"
set topall "top-all.top"
set topmonth "top-month.top"
set topweek "top-week.top"
set topday "top-day.top"
set authlog "_authlog.txt"
set nukelog "_nukelog.txt"
set uplog "_uplog.txt"
set hacklog "_hacklog.txt"

# The following conversion makes sure that all the characters in the approved channel list
# are lower case.
set approved_chans [string tolower $approved_chans]

# The following two if{} statements make sure that there is a space at the beginning and 
# end of the approved channel list.
if {[string index $approved_chans 0] != " "} {
   set approved_chans " $approved_chans"
}
if {[string index $approved_chans [expr [string length $approved_chans]-1]] != " "} {
   set approved_chans "$approved_chans "
}

# The follow if{} statements check to make sure that the variables have been defined,
# and/or defined correctly.
if {$servername == "My Server Name"} {
    die "ERROR IN G6STATS.TCL: SERVER NAME NOT DEFINED!"
}
if {![file exists $g6dir]} {
    die "ERROR IN G6STATS.TCL: PATH TO G6 FTP SERVER DOES NOT EXIST!"
}
if {$g6_trigger == "!MyTrigger"} {
    die "ERROR IN G6STATS.TCL: STATISTICS TRIGGER HAS NOT BE DEFINED!"
}
if {($greet_bot == "GreetBot")} {
    die "ERROR IN G6STATS.TCL: YOU HAVE NOT SPECIFIED A GREET BOT!"
}
if {$stats_started_date == "month-date-year"} {
    die "ERROR IN G6STATS.TCL: STATISTICS START-DATE HAS NOT BEEN DEFINED!"
}
if {![file exists $g6stats_dir]} {
    die "ERROR IN G6STATS.TCL: PATH TO G6STATS FILES IS INCORRECT!"
}
if {![file exists $g6stats_dir$newup_batchfile]} {
    die "ERROR LOADING G6STATS.TCL: NEWUP.BAT CANNOT BE FOUND"
}
if {$admin_pass == "adminpassword"} {
    die "ERROR LOADING G6STATS.TCL: ADMINISTRATIVE PASSWORD HAS NOT BEEN CHANGED!"
}
if {$msgnotify_list == "IRCNick1 IRCNick2 IRCNick3"} {
    die "ERROR LOADING G6STATS.TCL: NOTIFICATION NICKS MUST BE CHANGED!"
}
if {$icqnotify_list == "ICQUIN1 ICQUIN2 ICQUIN3"} {
    die "ERROR LOADING G6STATS.TCL: NOTIFICATION ICQ UIN'S MUST BE CHANGED!"
}
if {$approved_chans == "#chan1 #chan2 #chan3"} {
    die "ERROR LOADING G6STATS.TCL: YOU MUST CHANGE THE LIST OF APPROVED CHANNELS!"
}

bind msg +hp greet greetbot_greet_newuser
bind pub - $g6_trigger main
bind join - * request_greet
bind join - * greet_onjoin
bind msg - admin msg_admin
bind time - "59 23 * * *" log_cycle
bind time - "00 00 * * *" makedir


utimer $checkdelay pub_upannc


proc request_greet {nick uhost hand chan args} {
   global approved_chans greet_bot commandcolor g6_trigger helpflag replycolor botcolor botnick servercolor servername
   set chan [string tolower $chan]
   # If the a GreetBot has been specified, request a greeting that bot to the new user
   if {([string trim $greet_bot] != "") && ([string first " $chan " $approved_chans] != -1)} {
      puthelp "PRIVMSG $greet_bot : greet $nick $replycolor Type$commandcolor $g6_trigger $helpflag$replycolor in$commandcolor $chan$replycolor to view$botcolor $botnick's$replycolor available sitestat commands for$servercolor $servername"
   }
   return 0
}

proc greetbot_greet_newuser {nick uhost hand rest} {
   global greetbot_enabled botnick
   # If this bot is enabled to be a greet bot, welcome the newly joined user as requested.
   if {$greetbot_enabled} {
      set newuser [lindex $rest 0]
      set sendmsg $rest
      puthelp "PRIVMSG $newuser :[string trimleft [string range $rest [expr [string length $newuser]+1] end]]"
   } else {
      puthelp "PRIVMSG $nick : $botnick is not a GreetBot!"
   }
   return 0
}

proc greet_onjoin {nick uhost hand chan args} {
    global approved_chans greetnotice_enabled g6_trigger helpflag botnick botcolor commandcolor replycolor servercolor servername
    set chan [string tolower $chan]
    # If the newly joined channel been approved to view stats, and greet by notice has been enabled, give instructions to the person 
    # entering the channel as to how to use the g6stats script.
    if {$greetnotice_enabled} {
       if {[string first " $chan " $approved_chans] != -1} { 
          puthelp "NOTICE $nick :$replycolor Type$commandcolor $g6_trigger $helpflag$replycolor in$commandcolor $chan$replycolor to view$botcolor $botnick's$replycolor available sitestat commands for$servercolor $servername"
       }
    }
    return 0	
}

# This proc is what receives and interprets commands from the users, then sets up the reaction to the command with a header message.
proc main {nick uhost hand chan rest} {
    global chan_or_nick resetlog_flag nukeflag uploadcount_flag approved_chans uplog_flag nukelog_flag g6stats_dir uplog nukelog stats_started_date infoflag commandcolor botnick botcolor replycolor servercolor g6_trigger servername g6dir allflag monthflag weekflag dayflag helpflag topall topmonth topweek topday
    set chan [string tolower $chan]
    # If the request comes from an approved channel, continue on to fulfill the request
    if {[string first " $chan " $approved_chans] != -1} { 
       set cmd [string tolower [lindex $rest 0]]
       if {$chan_or_nick} {
          set output_location $chan
       } else {
          set output_location $nick
       }
       if {$cmd == $allflag} {
          set input_file $g6dir$topall
       	  puthelp "PRIVMSG $output_location :$replycolor All Time Statistics (since $stats_started_date) for$servercolor $servername"
          display_normal $input_file $output_location $nick
       } elseif {$cmd == $monthflag} {
          set input_file $g6dir$topmonth
          puthelp "PRIVMSG $output_location :$replycolor This Month's Statistics for$servercolor $servername"
          display_normal $input_file $output_location $nick
       } elseif {$cmd == $weekflag} {
          set input_file $g6dir$topweek
          puthelp "PRIVMSG $output_location :$replycolor This Week's Statistics for$servercolor $servername"
          display_normal $input_file $output_location $nick
       } elseif {$cmd == $dayflag} {
          set input_file $g6dir$topday
          puthelp "PRIVMSG $output_location :$replycolor Today's Statistics for$servercolor $servername"
          display_normal $input_file $output_location $nick
       } elseif {$cmd == $infoflag} {
          puthelp "PRIVMSG $output_location :$botcolor $botnick$replycolor is using$commandcolor G6Stats v4.20$replycolor by EsKiMo!"
          puthelp "PRIVMSG $output_location :$replycolor Special thanks to$commandcolor Abby$replycolor,$commandcolor Fireman$replycolor,$commandcolor Xoox$replycolor,$commandcolor _ABCDE_$replycolor,$commandcolor |Infern0|$replycolor, and$commandcolor simple$replycolor for assisting me and inspiring me in writing this script!"
          puthelp "PRIVMSG $output_location :$replycolor Download:$commandcolor http://www.tranceambient.com/downloads/g6stats.zip"
          puthelp "PRIVMSG $output_location :$replycolor Support:$commandcolor http://www.tranceambient.com/g6stats_support.html"
       } elseif {$cmd == $helpflag} {
          puthelp "PRIVMSG $output_location :$replycolor Here is the list of$botcolor $botnick's$replycolor available sitestat commands for$servercolor $servername"
          puthelp "PRIVMSG $output_location :$replycolor Command:$commandcolor $g6_trigger $infoflag    $replycolor Response:$commandcolor Displays script info"
          puthelp "PRIVMSG $output_location :$replycolor Command:$commandcolor $g6_trigger $allflag    $replycolor Response:$commandcolor Displays all time statistics"
          puthelp "PRIVMSG $output_location :$replycolor Command:$commandcolor $g6_trigger $monthflag    $replycolor Response:$commandcolor Displays this month's statistics"
          puthelp "PRIVMSG $output_location :$replycolor Command:$commandcolor $g6_trigger $weekflag    $replycolor Response:$commandcolor Displays this week's statistics"
          puthelp "PRIVMSG $output_location :$replycolor Command:$commandcolor $g6_trigger $dayflag    $replycolor Response:$commandcolor Displays today's statistics"
          puthelp "PRIVMSG $output_location :$replycolor Command:$commandcolor $g6_trigger $nukelog_flag    $replycolor Response:$commandcolor Displays today's nukelog"
          puthelp "PRIVMSG $output_location :$replycolor Command:$commandcolor $g6_trigger $uploadcount_flag    $replycolor Response:$commandcolor Displays the total number of today's uploads"    
          puthelp "PRIVMSG $output_location :$replycolor Command:$commandcolor $g6_trigger $uplog_flag all    $replycolor Response:$commandcolor Displays all of today's uploads"
          puthelp "PRIVMSG $output_location :$replycolor Command:$commandcolor $g6_trigger $uplog_flag <X Y>    $replycolor Response:$commandcolor Displays today's uploads between$replycolor X$commandcolor and$replycolor Y"
          puthelp "PRIVMSG $output_location :$replycolor Command:$commandcolor $g6_trigger $uplog_flag <X> end    $replycolor Response:$commandcolor Displays today's uploads between$replycolor X$commandcolor and the last upload"
          puthelp "PRIVMSG $output_location :$replycolor Command:$commandcolor $g6_trigger $resetlog_flag    $replycolor Response:$commandcolor Resets all daily activity logs"
          puthelp "PRIVMSG $output_location :$replycolor Command:$commandcolor $g6_trigger $nukeflag <\"upload to delete\"> \[reason\]    $replycolor Response:$commandcolor Nukes the specified upload"
          puthelp "PRIVMSG $output_location :$replycolor Command:$commandcolor /msg $botnick admin <password>   $replycolor Response:$commandcolor Authorizes you as an admin"  
       } elseif {$cmd == $resetlog_flag} {
          if {[check_auth $hand $nick $chan]} {
             log_cycle 0 0 0 0 0
             puthelp "PRIVMSG $output_location :$replycolor Daily activity logs reset successfully!"
          } else {
             set hackinfo "Unauthorized attempt to reset activity logs by $nick at $uhost"
             write_hacklog $hackinfo
             hack_notify $hackinfo
             puthelp "PRIVMSG $output_location :$replycolor You are not authorized to use that command!"
          }
       } elseif {$cmd == $nukelog_flag} {
          set input_file $g6stats_dir$nukelog
          puthelp "PRIVMSG $output_location :$replycolor Today's Nuke Log for$servercolor $servername"
          display_nukelog $input_file $output_location $nick
       } elseif {$cmd == $nukeflag} {
          pub_nuke $nick $uhost $hand $chan $output_location $rest 
       } elseif {$cmd == $uploadcount_flag} {
          puthelp "PRIVMSG $output_location :$replycolor There are$commandcolor [upload_count]$replycolor Uploads for Today at$servercolor $servername"
       } elseif {$cmd == $uplog_flag} {
          if {[file exists $g6stats_dir$uplog]} {
             set input_file $g6stats_dir$uplog
             set start_line [string tolower [lindex $rest 1]]
             set finish_line [string tolower [lindex $rest 2]]
             set uplog_length [upload_count]
             if {[string trim $start_line] == "" || [string tolower $start_line] == "all"} {
                set finish_line $uplog_length
                set start_line 1
             } elseif {[string tolower $finish_line] == "end"} {
                 set finish_line $uplog_length
             }
             puthelp "PRIVMSG $output_location :$replycolor Uploads$commandcolor $start_line$replycolor to$commandcolor $finish_line$replycolor out of$commandcolor $uplog_length$replycolor for today at$servercolor $servername"
             display_uplog $input_file $output_location $nick $start_line $finish_line $uplog_length
          } else {
             puthelp "PRIVMSG $output_location :$replycolor Sorry$commandcolor $nick$replycolor, there have not yet been any uploads today at$servercolor $servername"  
          }
       } elseif {$cmd == ""} {
          puthelp "PRIVMSG $output_location :$replycolor You must enter a command!"
          puthelp "PRIVMSG $output_location :$replycolor Type$commandcolor $g6_trigger $helpflag$replycolor to view$botcolor $botnick's$replycolor available sitestat commands for$servercolor $servername." 
       } else {
          puthelp "PRIVMSG $output_location :$commandcolor $cmd$replycolor is an unknown command!"
          puthelp "PRIVMSG $output_location :$replycolor Type$commandcolor $g6_trigger $helpflag$replycolor to view$botcolor $botnick's$replycolor available sitestat commands$servercolor $servername."
       }
    }  
}

# This proc counts and returns the number of uploads in the upload log (ie, the number of non-blank lines in the file)
proc upload_count {} {
   global g6stats_dir uplog
   set counter 0
   if {[file exists $g6stats_dir$uplog]} {
      set length_test_file [open $g6stats_dir$uplog r]
      while {![eof $length_test_file]} {
         if {[string trim [gets $length_test_file]] != ""} {
            incr counter
         }
      }
      close $length_test_file
   }
   return $counter
}


# This proc is used specifically to display the upload log
proc display_uplog {input_file chan nick start_line finish_line uplog_length} {
   global incoming_dir replycolor commandcolor uplog
   set chan [string tolower $chan]
   if {[file exists $input_file]} {
      puthelp "PRIVMSG $chan : "
      set openfile [open $input_file r]
      set counter 1
      while {(![eof $openfile]) && ($counter != [expr $finish_line+1])} {
         set file_readline [gets $openfile]
         regsub -all {\\} $file_readline {/} file_readline
         set incoming_dir_length [string length $incoming_dir]
         incr incoming_dir_length
         if {[string trim $file_readline] != ""} {
            set file_readline "\"[string range $file_readline $incoming_dir_length end]"
         }
         if {$counter >= $start_line} {
            puthelp "PRIVMSG $chan :$commandcolor $counter:$replycolor $file_readline"
         }
         incr counter
      }
      close $openfile
   } else {
      puthelp "PRIVMSG $chan :$replycolor I'm sorry$commandcolor $nick$replycolor , there isn't any data to be displayed from the file you requested!"
   }
}


# This proc is used specifically to display the nukelog
proc display_nukelog {input_file chan nick} {
   global incoming_dir replycolor commandcolor nukelog   
   set chan [string tolower $chan]
   if {[file exists $input_file]} {
      puthelp "PRIVMSG $chan : "
      set openfile [open $input_file r]
      while {![eof $openfile]} {
         set file_readline [gets $openfile]
         set incoming_dir_length [string length $incoming_dir]
         set file_readline [string range $file_readline $incoming_dir_length end]
         puthelp "PRIVMSG $chan :$replycolor $file_readline"
      }   
      close $openfile
   } else {
      puthelp "PRIVMSG $chan :$replycolor I'm sorry$commandcolor $nick$replycolor , there isn't any data to be displayed from the file you requested!"
   }
}


# This proc is used to display files with no special output needs
proc display_normal {input_file chan nick} {
   global replycolor commandcolor 
   set chan [string tolower $chan]
   if {[file exists $input_file]} {
      puthelp "PRIVMSG $chan : "
      set openfile [open $input_file r]
      while {![eof $openfile]} {
         set file_readline [gets $openfile]
         puthelp "PRIVMSG $chan :$replycolor $file_readline"
      }
      close $openfile
   } else {
      puthelp "PRIVMSG $chan :$replycolor I'm sorry$commandcolor $nick$replycolor , there isn't any data to be displayed from the file you requested!"
   }
}


# This proc is used to monitor for a new upload, and announce the new upload when it comes through
proc pub_upannc {} {
     global approved_chans incoming_dir replycolor commandcolor checkdelay g6stats_dir newup newup_copy fcopy servername servercolor
     # same_check is used as a flag to help determine if the newup.txt has changed (if it has the script assumes a new upload).
     # (same_check == 0) --> newup.txt and newup_copy.txt are the same
     # (same_check == 1) --> newup.txt and newup_copy.txt are different
     set same_check 0
     # If both files exist, or the first exists and the second is missing, continue
     if {([file exists $g6stats_dir$newup] && [file exists $g6stats_dir$newup_copy]) || ([file exists $g6stats_dir$newup] && ![file exists $g6stats_dir$newup_copy])} {
         # If the first file exists and the second is missing, indicate a new upload
            if {([file exists $g6stats_dir$newup] && ![file exists $g6stats_dir$newup_copy])} {
	    set openfile1 [open $g6stats_dir$newup r]
	    set file1_readline [gets $openfile1]
	    close $openfile1
	    set same_check 1
         } else {
            # Otherwise open both files and see if the first line is the same.
            # If the first lines are the same, indicate a new upload.
            set openfile1 [open $g6stats_dir$newup r]
            set file1_readline [gets $openfile1]
            close $openfile1
            set openfile2 [open $g6stats_dir$newup_copy r]
            set file2_readline [gets $openfile2]
            close $openfile2
            if {[string compare $file1_readline $file2_readline] != 0} {
               set same_check 1
            }
         }
         # If there was a new upload, announce it to the specified channels
         if {$same_check == 1} {
             regsub -all {\\} $file1_readline {/} file1_readline
             set incoming_dir_length [string length $incoming_dir]
             incr incoming_dir_length
             set file1_readline "\"[string range $file1_readline $incoming_dir_length end]"
             foreach chan $approved_chans {
                puthelp "PRIVMSG $chan : $servercolor $servername  $commandcolor *NEW UPLOAD*  $replycolor $file1_readline"
             }
             file copy -force $g6stats_dir$newup $g6stats_dir$newup_copy
             set same_check 0
         }   
     }
     
     # Start this function (pub_annc) again after the specified delay
     utimer $checkdelay pub_upannc
}
     

# This proc is what handles the authorization request
proc msg_admin {nick uhost hand rest} {
   global admin botnick admin_pass g6stats_dir authlog
   set pass $rest
# If the pass is correct, and the user appears on the userfile with at least +o flags, grant authorization
   if {($pass == $admin_pass) && ([matchattr $hand +o]) && ([validuser $nick])} {
       puthelp "PRIVMSG $nick : $nick from $uhost successfully authorized!"
       set write_authfile  [open $g6stats_dir$authlog a+]
       puts $write_authfile $nick
       puts $write_authfile $uhost
       close $write_authfile
   } else {
       puthelp "PRIVMSG $nick : Authorization failed!"
       set hackinfo "Failed authorization attempt by $nick at $uhost  (attempted password '$pass' to authorize)"
       write_hacklog $hackinfo
       hack_notify $hackinfo
   }
}


# This proc nukes the requested file/folder for the requested reason, as long as the user is authorized
proc pub_nuke {nick uhost hand chan output_location rest} {
   global admin botnick nukelog incoming_dir g6stats_dir
   set chan [string tolower $chan]
   set nuke_folder [string tolower [lindex $rest 1]]
   set reason [string tolower [lrange $rest 2 end]]
   if {[string trim $reason] == ""} {
      set reason "no reason given"
   }
   if {[check_auth $hand $nick $chan]} {
      if {[file exists $incoming_dir$nuke_folder]} {
	 file delete -force $incoming_dir$nuke_folder
	 set logfile [open $g6stats_dir$nukelog a+]
	 puts $logfile "$incoming_dir$nuke_folder   (nuked by: [string tolower $nick]  |  reason: [string tolower $reason])"
	 close $logfile
	 set parent_dir [file dirname $incoming_dir$nuke_folder]
	 append parent_dir "/"
	 if {[string index $nuke_folder [expr [string length $nuke_folder]-1]] == "/"} {
	    set nuke_folder [string range $nuke_folder 0 [expr [string length $nuke_folder]-2]]
	 }
	 set last_slash [string last {/} $incoming_dir$nuke_folder]
	 incr last_slash
	 set nuke_folder_without_path [string range $incoming_dir$nuke_folder $last_slash end]
	 set info_dir "!NUKED $nuke_folder_without_path  [string tolower ($reason)]"
	 file mkdir $parent_dir$info_dir 
	 puthelp "PRIVMSG $output_location : $incoming_dir$nuke_folder deleted successfully!"
      } else {
	 puthelp "PRIVMSG $output_location : Unable to find and/or delete $incoming_dir$nuke_folder !"
      }
   } else {
      set hackinfo "Unauthorized nuke attempt by $nick at $uhost (attempted to nuke $incoming_dir$nuke_folder from within $chan)"
      write_hacklog $hackinfo
      hack_notify $hackinfo
      puthelp "PRIVMSG $output_location : You are not authorized to request that action!"
   }  
}

# This proc is used to determine if a user is authorized to perform the action requested
proc check_auth {hand nick chan} {
   global approved_chans g6stats_dir authlog
   if {([matchattr $hand +o]) && ([validuser $nick]) && ([file exists $g6stats_dir$authlog]) && [string first " $chan " $approved_chans] != -1} {
      set openfile [open $g6stats_dir$authlog r]
      set auth_nick [gets $openfile]
      set auth_host [gets $openfile]
      while {$nick != $auth_nick && $uhost != $auth_host && ![eof $openfile]} {
          set auth_nick [gets $openfile]
          set auth_host [gets $openfile]
      }
      if {![eof $openfile]} {
         close $openfile
         return 1
      }
      close $openfile
   }
   return 0
}


# This proc is used to write information to the hack attempt log
proc write_hacklog {hackinfo} {
   global g6stats_dir hacklog
   set write_hacklog [open $g6stats_dir$hacklog a+]
   puts $write_hacklog $hackinfo
   close $write_hacklog
   return 0
}


# This proc is called upon when a hack attempt is detected, and has the capability to send msg's
# over ICQ and/or ICQ WWP
proc hack_notify {msg} {
   global icqnotify_list msgnotify_list botnick
   if {[string trim $msgnotify_list] != ""} {
      foreach notify_nick $msgnotify_list {
         puthelp "PRIVMSG $notify_nick :$msg"
      }
      putlog "MSG Notifications Sent"
   }
   if {[string trim $icqnotify_list] != ""} {
      foreach icq $icqnotify_list {
         set hand $botnick
         regsub -all " " $msg + mssg
         set head "Msg from $botnick"
         set chan $botnick
         regsub -all " " $head + hed
         set body $hed
         append body $mssg
         set var $body
         append var $hand
         append var $chan
         append var $botnick
         set l [string length $var]
         set ln [expr $l + 41]
         if [catch {socket "wwp.icq.com" 80} sockresult] {
            putlog "Could not connect:  $sockresult"
            return
         }
         fconfigure $sockresult -translation auto -buffering line -blocking 0
         puts $sockresult "POST /scripts/WWPMsg.dll HTTP/1.1"
         puts $sockresult "Accept: application/vnd.ms-excel, application/msword, application/vnd.ms-powerpoint, image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*"
         puts $sockresult "Referer: http://nothing.com"
         puts $sockresult "Accept-Language: en-u"
         puts $sockresult "s"
         puts $sockresult "Content-Type: application/x-www-form-urlencoded"
         puts $sockresult "Accept-Encoding: gzip, deflate"
         puts $sockresult "User-Agent: Mozilla/4.0 (compatible; MSIE 4.01; Windows 95)"
         puts $sockresult "Host: x"
         puts $sockresult "Content-Length: $ln"
         puts $sockresult "Connection: Keep-Alive"
         puts $sockresult ""
         puts $sockresult "subject=$hed&to=$icq&from=$hand&fromemail=$chan&body=$mssg&x=90&y=50"
         close $sockresult
      }
      putlog "ICQ Notifications Sent"
   }
}


# This proc is used to cycle the logs at 11:59pm every night
proc log_cycle {min hour day month year} {
    global hacklog log_archive_dir g6stats_dir uplog nukelog authlog retain_authlog
    set cycle_timedate [clock seconds]
    set cycle_date [clock format $cycle_timedate -format "%m-%d-%y"]  
    if {![file exists $log_archive_dir]} {mkdir $log_archive_dir}
    if {[file exists $g6stats_dir$nukelog]} {
       if {[string trim $log_archive_dir] != ""} {
          if {[file exists $log_archive_dir$cycle_date$nukelog]} {
             append_files $g6stats_dir$nukelog $log_archive_dir$cycle_date$nukelog
          } else { 
             file copy -force $g6stats_dir$nukelog $log_archive_dir$cycle_date$nukelog
          }
       }
       file delete -force $g6stats_dir$nukelog
    }
    if {[file exists $g6stats_dir$uplog]} {
       if {[string trim $log_archive_dir] != ""} {
          if {[file exists $log_archive_dir$cycle_date$uplog]} {
             append_files $g6stats_dir$uplog $log_archive_dir$cycle_date$uplog
          } else {
             file copy -force $g6stats_dir$uplog $log_archive_dir$cycle_date$uplog
          }
       }
       file delete -force $g6stats_dir$uplog
    }
    if {[file exists $g6stats_dir$authlog]} {
       if {[string trim $log_archive_dir] != ""} {
          if {[file exists $log_archive_dir$cycle_date$authlog]} {
             append_files $g6stats_dir$authlog $log_archive_dir$cycle_date$authlog
          } else {
             file copy -force $g6stats_dir$authlog $log_archive_dir$cycle_date$authlog
          }
       }
       if {!$retain_authlog} {
          file delete -force $g6stats_dir$authlog
       }
    }
    if {[file exists $g6stats_dir$hacklog]} {
       if {[string trim $log_archive_dir] != ""} {
          if {[file exists $log_archive_dir$cycle_date$hacklog]} {
             append_files $g6stats_dir$hacklog $log_archive_dir$cycle_date$hacklog
          } else {
             file copy -force $g6stats_dir$hacklog $log_archive_dir$cycle_date$hacklog
          }
       }
       file delete -force $g6stats_dir$hacklog
    }
   
}

# This proc takes a file and appends it to another file
# NOTE: It does not append blank spaces
proc append_files {current_file archived_file} {
   set current [open $current_file r]
   set archived [open $archived_file a]
   while {![eof $current]} {
      set to_append [gets $current]
      if {[string trim $to_append] != ""} {
         puts $archived $to_append   
      }
   }
   close $current
   close $archived
}
   

# This proc is used to create a date-stamped folder at midnight every night.
proc makedir {min hour day month year} {
   global midnight_dir midnight_dir_format
   if {[string trim $midnight_dir] != ""} {
      set temp [clock seconds]
      set dirname [clock format $temp -format $midnight_dir_format]
      if {![file exists $midnight_dir]} {
         file mkdir $midnight_dir
      }
      file mkdir $midnight_dir$dirname
   }
}

putlog "G6Stats v4.20 by EsKiMo loaded successfully!"    


